Ant.OS.GUI.tag = {}
Ant.OS.GUI.zindex = 10
class Ant.OS.GUI.BaseTag
    constructor: (@root,  @observable) ->
        @opts = {}
        me = @
        @observable = new Ant.OS.API.Announcer() unless @observable
        # export to rootnode
        @root.observable = @observable
        @root.set = (k, v) -> me.set k, v
        @root.get = (k) -> me.get k
        @root.aid = () -> me.aid()
        @root.calibrate = () -> me.calibrate()
        @mounted = false
        @root.sync = () -> me.sync()
        @refs = {}
        @setopt "data-id", (Math.floor(Math.random() * 100000) + 1).toString()
        #$(@root).attr "data-id", @get("data-id")
        @children = $(@root).children()
        
        for obj in @layout()
            dom = @mkui obj
            if dom
                $(dom).appendTo(@root)
        if @refs.yield
            $(v).detach().appendTo @refs.yield for v in @children
        else
            @children = []
        $(@root).children().each () -> @.mkui me.observable

    __: (k, v) ->
            @set k, v if v
            @get k

    setopt: (name, val) ->
        value = val
        if ($(@root).attr name)
            v = $(@root).attr name
            try
                value = JSON.parse(v)
            catch e
                value = v
        @set name, value
    
    set: (opt, value) ->
        if opt is "*"
            @set k, v for k, v of value
        else
            @["__#{opt}"](value) if @["__#{opt}"]
            @opts[opt] = value
            @["__#{opt}__"](value) if @["__#{opt}__"]
        @
    
    aid: () ->
        @get "data-id"
    
    calibrate: () ->

    get: (opt) ->
        return @opts if opt is "*"
        @opts[opt]

    sync: () ->
        return if @mounted
        @mounted = true
        @mount()
        $(@root).children().each () -> @.mount()
        @root

    mount: () ->

    layout: () ->
        []
        # should be defined by subclasses

    mkui: (tag) ->
        return undefined unless tag
        dom = $("<#{tag.el}>")
        $(dom).addClass tag.class if tag.class
        if tag.children
            $(@mkui(v)).appendTo(dom) for v in tag.children
        if tag.ref
            @refs[tag.ref] = dom[0]
        # dom.mount @observable
        dom[0] #.uify(@observable)

Element.prototype.mkui = (observable) ->
    tag = @tagName.toLowerCase()
    if RegExp("afx-*", "i" ).test(tag) and Ant.OS.GUI.tag[tag]
        o = new Ant.OS.GUI.tag[tag](@, observable)
        return o.root
    else
        $(@).children().each () ->
            @mkui(observable)
    return @


Element.prototype.mount = () ->
    return @sync() if @sync
    $(@).children().each () -> @mount()
    @

Element.prototype.uify = (observable) ->
    @mkui(observable)
    @sync()

Ant.OS.GUI.define = (name, cls) ->
    Ant.OS.GUI.tag[name] = cls

